What's the purpose of “true” in bash “if sudo true; then”How can I adjust this short shell script to fit my needs?Security of sudo not asking for a password after the first timeCan't give myself NOPASSWD privelege for chmod/chownHow to prevent the caller's shell from being used in sudoScript that asks for four words, then tells the user the word they chose. Output error?Sudo specific command with no passwordHave a command in my $PATH, but it is not being recognized when I use sudoHow to check a set of lines in a text file for patterns using awk, sed, or grep?Which user's password does `sudo` asks for?Does sudo restrict on which users can acquire superuser privileges?

when is out of tune ok?

Would a high gravity rocky planet be guaranteed to have an atmosphere?

How to check is there any negative term in a large list?

Two monoidal structures and copowering

How can we prove that any integral in the set of non-elementary integrals cannot be expressed in the form of elementary functions?

Avoiding estate tax by giving multiple gifts

Term for the "extreme-extension" version of a straw man fallacy?

Customer Requests (Sometimes) Drive Me Bonkers!

Increase performance creating Mandelbrot set in python

What is the opposite of 'gravitas'?

Why, precisely, is argon used in neutrino experiments?

Large drywall patch supports

You cannot touch me, but I can touch you, who am I?

How to write papers efficiently when English isn't my first language?

How to Reset Passwords on Multiple Websites Easily?

Lay out the Carpet

Is there a problem with hiding "forgot password" until it's needed?

What does the word "Atten" mean?

How to run a prison with the smallest amount of guards?

Detecting if an element is found inside a container

Integer addition + constant, is it a group?

Sort a list by elements of another list

Is `x >> pure y` equivalent to `liftM (const y) x`

How did Arya survive the stabbing?



What's the purpose of “true” in bash “if sudo true; then”


How can I adjust this short shell script to fit my needs?Security of sudo not asking for a password after the first timeCan't give myself NOPASSWD privelege for chmod/chownHow to prevent the caller's shell from being used in sudoScript that asks for four words, then tells the user the word they chose. Output error?Sudo specific command with no passwordHave a command in my $PATH, but it is not being recognized when I use sudoHow to check a set of lines in a text file for patterns using awk, sed, or grep?Which user's password does `sudo` asks for?Does sudo restrict on which users can acquire superuser privileges?













17















I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question









New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.















  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    yesterday







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    yesterday






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    yesterday






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    yesterday






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    yesterday
















17















I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question









New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.















  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    yesterday







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    yesterday






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    yesterday






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    yesterday






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    yesterday














17












17








17








I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question









New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.












I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then






bash sudo






share|improve this question









New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.











share|improve this question









New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









share|improve this question




share|improve this question








edited 13 hours ago







Matt Parkins













New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









asked yesterday









Matt ParkinsMatt Parkins

19717




19717




New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.





New contributor





Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.






Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.







  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    yesterday







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    yesterday






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    yesterday






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    yesterday






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    yesterday













  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    yesterday







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    yesterday






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    yesterday






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    yesterday






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    yesterday








2




2





If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

– Matt Parkins
yesterday






If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

– Matt Parkins
yesterday





4




4





Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

– Jeff Schaller
yesterday





Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

– Jeff Schaller
yesterday




1




1





see stackoverflow.com/q/10552711/537980

– ctrl-alt-delor
yesterday





see stackoverflow.com/q/10552711/537980

– ctrl-alt-delor
yesterday




1




1





@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

– Matt Parkins
yesterday





@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

– Matt Parkins
yesterday




2




2





In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

– Toby Speight
yesterday






In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

– Toby Speight
yesterday











2 Answers
2






active

oldest

votes


















36














true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer








New contributor




JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.















  • 10





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    yesterday







  • 30





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    yesterday







  • 2





    @IMSoP That's deep.

    – brainplot
    12 hours ago











  • @IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expect true to ever be called nearly often enough to matter.

    – John Dvorak
    11 hours ago






  • 1





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    7 hours ago


















17














I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer


















  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    21 hours ago






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    21 hours ago







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    21 hours ago






  • 1





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    10 hours ago






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    6 hours ago










Your Answer








StackExchange.ready(function()
var channelOptions =
tags: "".split(" "),
id: "106"
;
initTagRenderer("".split(" "), "".split(" "), channelOptions);

StackExchange.using("externalEditor", function()
// Have to fire editor after snippets, if snippets enabled
if (StackExchange.settings.snippets.snippetsEnabled)
StackExchange.using("snippets", function()
createEditor();
);

else
createEditor();

);

function createEditor()
StackExchange.prepareEditor(
heartbeatType: 'answer',
autoActivateHeartbeat: false,
convertImagesToLinks: false,
noModals: true,
showLowRepImageUploadWarning: true,
reputationToPostImages: null,
bindNavPrevention: true,
postfix: "",
imageUploader:
brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
allowUrls: true
,
onDemand: true,
discardSelector: ".discard-answer"
,immediatelyShowMarkdownHelp:true
);



);






Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.









draft saved

draft discarded


















StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508756%2fwhats-the-purpose-of-true-in-bash-if-sudo-true-then%23new-answer', 'question_page');

);

Post as a guest















Required, but never shown

























2 Answers
2






active

oldest

votes








2 Answers
2






active

oldest

votes









active

oldest

votes






active

oldest

votes









36














true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer








New contributor




JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.















  • 10





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    yesterday







  • 30





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    yesterday







  • 2





    @IMSoP That's deep.

    – brainplot
    12 hours ago











  • @IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expect true to ever be called nearly often enough to matter.

    – John Dvorak
    11 hours ago






  • 1





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    7 hours ago















36














true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer








New contributor




JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.















  • 10





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    yesterday







  • 30





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    yesterday







  • 2





    @IMSoP That's deep.

    – brainplot
    12 hours ago











  • @IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expect true to ever be called nearly often enough to matter.

    – John Dvorak
    11 hours ago






  • 1





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    7 hours ago













36












36








36







true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer








New contributor




JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.










true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;






share|improve this answer








New contributor




JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









share|improve this answer



share|improve this answer






New contributor




JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









answered yesterday









JShorthouseJShorthouse

50728




50728




New contributor




JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.





New contributor





JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.






JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.







  • 10





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    yesterday







  • 30





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    yesterday







  • 2





    @IMSoP That's deep.

    – brainplot
    12 hours ago











  • @IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expect true to ever be called nearly often enough to matter.

    – John Dvorak
    11 hours ago






  • 1





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    7 hours ago












  • 10





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    yesterday







  • 30





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    yesterday







  • 2





    @IMSoP That's deep.

    – brainplot
    12 hours ago











  • @IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expect true to ever be called nearly often enough to matter.

    – John Dvorak
    11 hours ago






  • 1





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    7 hours ago







10




10





As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

– IMSoP
yesterday






As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

– IMSoP
yesterday





30




30





PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

– IMSoP
yesterday






PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

– IMSoP
yesterday





2




2





@IMSoP That's deep.

– brainplot
12 hours ago





@IMSoP That's deep.

– brainplot
12 hours ago













@IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expect true to ever be called nearly often enough to matter.

– John Dvorak
11 hours ago





@IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expect true to ever be called nearly often enough to matter.

– John Dvorak
11 hours ago




1




1





If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

– nigel222
7 hours ago





If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

– nigel222
7 hours ago













17














I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer


















  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    21 hours ago






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    21 hours ago







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    21 hours ago






  • 1





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    10 hours ago






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    6 hours ago















17














I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer


















  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    21 hours ago






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    21 hours ago







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    21 hours ago






  • 1





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    10 hours ago






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    6 hours ago













17












17








17







I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer













I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.







share|improve this answer












share|improve this answer



share|improve this answer










answered yesterday









MehrdadMehrdad

1,37641534




1,37641534







  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    21 hours ago






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    21 hours ago







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    21 hours ago






  • 1





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    10 hours ago






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    6 hours ago












  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    21 hours ago






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    21 hours ago







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    21 hours ago






  • 1





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    10 hours ago






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    6 hours ago







1




1





Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

– Sergiy Kolodyazhnyy
21 hours ago





Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

– Sergiy Kolodyazhnyy
21 hours ago




3




3





Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

– Mehrdad
21 hours ago






Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

– Mehrdad
21 hours ago





1




1





The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

– mckenzm
21 hours ago





The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

– mckenzm
21 hours ago




1




1





And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

– Dave Sherohman
10 hours ago





And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

– Dave Sherohman
10 hours ago




2




2





Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

– jrw32982
6 hours ago





Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

– jrw32982
6 hours ago










Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.









draft saved

draft discarded


















Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.












Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.











Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.














Thanks for contributing an answer to Unix & Linux Stack Exchange!


  • Please be sure to answer the question. Provide details and share your research!

But avoid


  • Asking for help, clarification, or responding to other answers.

  • Making statements based on opinion; back them up with references or personal experience.

To learn more, see our tips on writing great answers.




draft saved


draft discarded














StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508756%2fwhats-the-purpose-of-true-in-bash-if-sudo-true-then%23new-answer', 'question_page');

);

Post as a guest















Required, but never shown





















































Required, but never shown














Required, but never shown












Required, but never shown







Required, but never shown

































Required, but never shown














Required, but never shown












Required, but never shown







Required, but never shown







-bash, sudo

Popular posts from this blog

Mobil Contents History Mobil brands Former Mobil brands Lukoil transaction Mobil UK Mobil Australia Mobil New Zealand Mobil Greece Mobil in Japan Mobil in Canada Mobil Egypt See also References External links Navigation menuwww.mobil.com"Mobil Corporation"the original"Our Houston campus""Business & Finance: Socony-Vacuum Corp.""Popular Mechanics""Lubrite Technologies""Exxon Mobil campus 'clearly happening'""Toledo Blade - Google News Archive Search""The Lion and the Moose - How 2 Executives Pulled off the Biggest Merger Ever""ExxonMobil Press Release""Lubricants""Archived copy"the original"Mobil 1™ and Mobil Super™ motor oil and synthetic motor oil - Mobil™ Motor Oils""Mobil Delvac""Mobil Industrial website""The State of Competition in Gasoline Marketing: The Effects of Refiner Operations at Retail""Mobil Travel Guide to become Forbes Travel Guide""Hotel Rankings: Forbes Merges with Mobil"the original"Jamieson oil industry history""Mobil news""Caltex pumps for control""Watchdog blocks Caltex bid""Exxon Mobil sells service station network""Mobil Oil New Zealand Limited is New Zealand's oldest oil company, with predecessor companies having first established a presence in the country in 1896""ExxonMobil subsidiaries have a business history in New Zealand stretching back more than 120 years. We are involved in petroleum refining and distribution and the marketing of fuels, lubricants and chemical products""Archived copy"the original"Exxon Mobil to Sell Its Japanese Arm for $3.9 Billion""Gas station merger will end Esso and Mobil's long run in Japan""Esso moves to affiliate itself with PC Optimum, no longer Aeroplan, in loyalty point switch""Mobil brand of gas stations to launch in Canada after deal for 213 Loblaws-owned locations""Mobil Nears Completion of Rebranding 200 Loblaw Gas Stations""Learn about ExxonMobil's operations in Egypt""Petrol and Diesel Service Stations in Egypt - Mobil"Official websiteExxon Mobil corporate websiteMobil Industrial official websiteeeeeeeeDA04275022275790-40000 0001 0860 5061n82045453134887257134887257

Frič See also Navigation menuinternal link

Identify plant with long narrow paired leaves and reddish stems Planned maintenance scheduled April 17/18, 2019 at 00:00UTC (8:00pm US/Eastern) Announcing the arrival of Valued Associate #679: Cesar Manara Unicorn Meta Zoo #1: Why another podcast?What is this plant with long sharp leaves? Is it a weed?What is this 3ft high, stalky plant, with mid sized narrow leaves?What is this young shrub with opposite ovate, crenate leaves and reddish stems?What is this plant with large broad serrated leaves?Identify this upright branching weed with long leaves and reddish stemsPlease help me identify this bulbous plant with long, broad leaves and white flowersWhat is this small annual with narrow gray/green leaves and rust colored daisy-type flowers?What is this chilli plant?Does anyone know what type of chilli plant this is?Help identify this plant